from enum import Enum


class MonkeyKnowledge(Enum):
    """
    *New in 0.5.0*

    The Monkey Knowledge points present in the game.
    """
    EXTRA_DART_POPS = "Extra Dart Pops"
    FAST_TACK_ATTACKS = "Fast Tack Attacks"
    INCREASED_LIFESPAN = "Increased Lifespan"
    FRAGGY_FRAGS = "Fraggy Frags"
    FAST_GLUE = "Fast Glue"
    HARD_TACKS = "Hard Tacks"
    CHEAP_RANGS = "Cheap Rangs"
    ELITE_MILITARY_TRAINING = "Elite Military Training"
    AIRFORCE_UPGRADES = "Airforce Upgrades"
    NAVAL_UPGRADES = "Naval Upgrades"
    MAGIC_TRICKS = "Magic Tricks"
    FLAT_PACK_BUILDINGS = "Flat Pack Buildings"
    ONE_MORE_SPIKE = "One More Spike"
    MORE_VALUABLE_BANANAS = "More Valuable Bananas"
    SPEEDY_BREWING = "Speedy Brewing"
    MO_MONKEY_MONEY = "Mo Monkey Money"
    LINGERING_MAGIC = "Lingering Magic"
    HOT_MAGIC = "Hot Magic"
    FLAME_JET = "Flame Jet"
    ARCANE_IMPALE = "Arcane Impale"
    SUPER_RANGE = "Super Range"
    MANA_SHIELD = "Mana Shield"
    BUDGET_CLUSTERS = "Budget Clusters"
    ICY_CHILL = "Icy Chill"
    CROSSBOW_REACH = "Crossbow Reach"
    FOUR_AND_FOuR = "4 And 4"
    MASTER_DOUBLE_CROSS = "Master Double Cross"
    BONUS_MONKEY = "Bonus Monkey"
    MORE_SPLATTY_GLUE = "More Splatty Glue"
    AVIATION_GRADE_GLUE = "Aviation Grade Glue"
    CHEAPER_SOLUTION = "Cheaper Solution"
    MORE_CASH = "More Cash"
    MORE_SPLODY = "More Splody"
    SCHOLARSHIPS = "Scholarships"
    HEROIC_REACH = "Heroic Reach"
    SELF_TAUGHT_HEROES = "Self Taught Heroes"
    HEROIC_VELOCITY = "Heroic Velocity"
    QUICK_HANDS = "Quick Hands"
    HERO_FAVORS = "Hero Favors"
    EMPOWERED_HEROES = "Empowered Heroes"
    ABILITY_DISCIPLINE = "Ability Discipline"
    ABILITY_MASTERY = "Ability Mastery"
    BIG_BLOON_BLUEPRINTS = "Big Bloon Blueprints"
    BIG_BUNCH = "Big Bunch"
    CERAMIC_SHOCK = "Ceramic Shock"
    CHEAPER_MAIMING = "Cheaper Maiming"
    BREAKING_BALLISTIC = "Breaking Ballistic"
    RAPID_RAZORS = "Rapid Razors"
    CHARGED_CHINOOKS = "Charged Chinooks"
    QUAD_BURST = "Quad Burst"
    MASTER_DEFENDER = "Master Defender"
    FASTER_TAKEDOWNS = "Faster Takedowns"
    FARM_SUBSIDY = "Farm Subsidy"
    WEAK_POINT = "Weak Point"
    CHEAPER_DOUBLES = "Cheaper Doubles"
    INSIDER_TRADES = "Insider Trades"
    VIGILANT_SENTRIES = "Vigilant Sentries"
    BIGGER_BANKS = "Bigger Banks"
    HEAVY_KNOCKBACK = "Heavy Knockback"
    STRIKE_DOWN_THE_FALSE = "Strike Down The False"
    STRONG_TONIC = "Strong Tonic"
    ACCELERATED_AERODARTS = "Accelerated Aerodarts"
    EXTRA_BURNY_STUFF = "Extra Burny Stuff"
    POPPY_BLADES = "Poppy Blades"
    BIG_INFERNO = "Big Inferno"
    TRADE_AGREEMENTS = "Trade Agreements"
    EXTRA_BOUNCE = "Extra Bounce"
    SUB_ADMIRAL = "Sub Admiral"
    RECURRING_RANGS = "Recurring Rangs"
    BIG_BLOON_SABOTAGE = "Big Bloon Sabotage"
    EMERGENCY_UNLOCK = "Emergency Unlock"
    FIRST_LAST_LINE_OF_DEFENSE = "First Last Line Of Defense"
    MONKEY_EDUCATION = "Monkey Education"
    GORGON_STORM = "Gorgon Storm"
    FORCE_VS_FORCE = "Force Vs Force"
    BONUS_GLUE_GUNNER = "Bonus Glue Gunner"
    TARGETED_PINEAPPLES = "Targeted Pineapples"
    GUN_COOLANT = "Gun Coolant"
    AERONAUTIC_SUBSIDY = "Aeronautic Subsidy"
    WINGMONKEY = "Wingmonkey"
    MONKEYS_TOGETHER_STRONG = "Monkeys Together Strong"
    XRAY_ULTRA = "Xray Ultra"
    THERE_CAN_BE_ONLY_ONE = "There Can Be Only One"
    MILITARY_CONSCRIPTION = "Military Conscription"
    CROSS_THE_STREAMS = "Cross The Streams"
    JUST_ONE_MORE = "Just One More"
    LONGER_DART_TIME = "Longer Dart Time"
    CHEAPER_LAKES = "Cheaper Lakes"
    LONGER_BOOSTS = "Longer Boosts"
    PRE_GAME_PREP = "Pre Game Prep"
    PAINT_STRIPPER = "Paint Stripper"
    INLAND_REVENUE_STREAMS = "Inland Revenue Streams"
    BACKROOM_DEALS = "Backroom Deals"
    BETTER_SELL_DEALS = "Better Sell Deals"
    THICKER_FOAMS = "Thicker Foams"
    BIG_TRAPS = "Big Traps"
    HEALTHY_BANANAS = "Healthy Bananas"
    SO_COLD = "So Cold"
    COME_ON_EVERYBODY = "Come On Everybody"
    DOOR_GUNNER = "Door Gunner"
    ADVANCED_LOGISTICS = "Advanced Logistics"
    FLANKING_MANEUVERS = "Flanking Maneuvers"
    BUDGET_BATTERY = "Budget Battery"
    VERY_SHREDDY = "Very Shreddy"
    HARD_PRESS = "Hard Press"
    HI_VALUE_MINES = "Hi Value Mines"
    TO_ARMS = "To Arms"
    VETERAN_MONKEY_TRAINING = "Veteran Monkey Training"
    GLOBAL_ABILITY_COOLDOWNS = "Global Ability Cooldowns"
    WARM_OAK = "Warm Oak"
    COLD_FRONT = "Cold Front"
    VINE_RUPTURE = "Vine Rupture"
    DIVERSION_TACTICS = "Diversion Tactics"
    DEADLY_TRANQUILITY = "Deadly Tranquility"
    TINY_TORNADOES = "Tiny Tornadoes"
    MEGA_MAULER = "Mega Mauler"
    LONG_TURBO = "Long Turbo"
    BIONIC_AUGMENTATION = "Bionic Augmentation"
    BUDGET_PONTOONS = "Budget Pontoons"
    POWERFUL_MONKEY_STORM = "Powerful Monkey Storm"
    FIT_FARMERS = "Fit Farmers"
    SUPA_THRIVE = "Supa Thrive"
    VIOLENT_IMPACT = "Violent Impact"
    BIG_CRYO_BLAST = "Big Cryo Blast"
    HYPOTHERMIA = "Hypothermia"
    BUDGET_CASH_DROPS = "Budget Cash Drops"
    GRAND_PRIX_SPREE = "Grand Prix Spree"
    ACID_STABILITY = "Acid Stability"
    BIGGER_CAMO_TRAP = "Bigger Camo Trap"

    @staticmethod
    def from_string(value: str) -> "MonkeyKnowledge":
        value = value.replace(" ", "")
        return mk_switch[value] if value in mk_switch else None


mk_switch = {}
for mk in MonkeyKnowledge:
    mk_switch[mk.value.replace(" ", "")] = mk


class Upgrade(Enum):
    """
    *New in 0.5.0*

    Every single tower upgrade present in the game.
    """
    DART_TOP_1 = "Sharp Shots"
    DART_TOP_2 = "Razor Sharp Shots"
    DART_TOP_3 = "Spike-o-pult"
    DART_TOP_4 = "Juggernaut"
    DART_TOP_5 = "Ultra-Juggernaut"
    DART_MID_1 = "Quick Shots"
    DART_MID_2 = "Very Quick Shots"
    DART_MID_3 = "Triple Shot"
    DART_MID_4 = "Super Monkey Fan Club"
    DART_MID_5 = "Plasma Monkey Fan Club"
    DART_BTM_1 = "Long Range Darts"
    DART_BTM_2 = "Enhanced Eyesight"
    DART_BTM_3 = "Crossbow"
    DART_BTM_4 = "Sharp Shooter"
    DART_BTM_5 = "Crossbow Master"
    DART_PARAGON = "Apex Plasma Master"

    BOMB_TOP_1 = "Bigger Bombs"
    BOMB_TOP_2 = "Heavy Bombs"
    BOMB_TOP_3 = "Really Big Bombs"
    BOMB_TOP_4 = "Bloon Impact"
    BOMB_TOP_5 = "Bloon Crush"
    BOMB_MID_1 = "Faster Reload"
    BOMB_MID_2 = "Missile Launcher"
    BOMB_MID_3 = "MOAB Mauler"
    BOMB_MID_4 = "MOAB Assassin"
    BOMB_MID_5 = "MOAB Eliminator"
    BOMB_BTM_1 = "Extra Range"
    BOMB_BTM_2 = "Frag Bombs"
    BOMB_BTM_3 = "Cluster Bombs"
    BOMB_BTM_4 = "Recursive Cluster"
    BOMB_BTM_5 = "Bomb Blitz"
    BOMB_PARAGON = None

    TACK_TOP_1 = "Faster Shooting"
    TACK_TOP_2 = "Even Faster Shooting"
    TACK_TOP_3 = "Hot Shots"
    TACK_TOP_4 = "Ring of Fire"
    TACK_TOP_5 = "Inferno Ring"
    TACK_MID_1 = "Long Range Tacks"
    TACK_MID_2 = "Super Range Tacks"
    TACK_MID_3 = "Blade Shooter"
    TACK_MID_4 = "Blade Maelstrom"
    TACK_MID_5 = "Super Maelstrom"
    TACK_BTM_1 = "More Tacks"
    TACK_BTM_2 = "Even More Tacks"
    TACK_BTM_3 = "Tack Sprayer"
    TACK_BTM_4 = "Overdrive"
    TACK_BTM_5 = "The Tack Zone"
    TACK_PARAGON = None

    GLUE_TOP_1 = "Glue Soak"
    GLUE_TOP_2 = "Corrosive Glue"
    GLUE_TOP_3 = "Bloon Dissolver"
    GLUE_TOP_4 = "Bloon Liquefier"
    GLUE_TOP_5 = "The Bloon Solver"
    GLUE_MID_1 = "Bigger Globs"
    GLUE_MID_2 = "Glue Splatter"
    GLUE_MID_3 = "Glue Hose"
    GLUE_MID_4 = "Glue Strike"
    GLUE_MID_5 = "Glue Storm"
    GLUE_BTM_1 = "Stickier Glue"
    GLUE_BTM_2 = "Stronger Glue"
    GLUE_BTM_3 = "MOAB Glue"
    GLUE_BTM_4 = "Relentless Glue"
    GLUE_BTM_5 = "Super Glue"
    GLUE_PARAGON = None

    ENGINEER_TOP_1 = "Sentry Gun"
    ENGINEER_TOP_2 = "Faster Engineering"
    ENGINEER_TOP_3 = "Sprockets"
    ENGINEER_TOP_4 = "Sentry Expert"
    ENGINEER_TOP_5 = "Sentry Champion"
    ENGINEER_MID_1 = "Larger Service Area"
    ENGINEER_MID_2 = "Deconstruction"
    ENGINEER_MID_3 = "Cleansing Foam"
    ENGINEER_MID_4 = "Overclock"
    ENGINEER_MID_5 = "Ultraboost"
    ENGINEER_BTM_1 = "Oversize Nails"
    ENGINEER_BTM_2 = "Pin"
    ENGINEER_BTM_3 = "Double Gun"
    ENGINEER_BTM_4 = "Bloon Trap"
    ENGINEER_BTM_5 = "XXXL Trap"
    ENGINEER_PARAGON = "Master Builder"

    DARTLING_TOP_1 = "Focused Firing"
    DARTLING_TOP_2 = "Laser Shock"
    DARTLING_TOP_3 = "Laser Cannon"
    DARTLING_TOP_4 = "Plasma Accelerator"
    DARTLING_TOP_5 = "Ray of Doom"
    DARTLING_MID_1 = "Advanced Targeting"
    DARTLING_MID_2 = "Faster Swivel"
    DARTLING_MID_3 = "Hydra Rocket Pods"
    DARTLING_MID_4 = "Rocket Storm"
    DARTLING_MID_5 = "M.A.D"
    DARTLING_BTM_1 = "Faster Barrel Spin"
    DARTLING_BTM_2 = "Powerful Darts"
    DARTLING_BTM_3 = "Buckshot"
    DARTLING_BTM_4 = "Bloon Area Denial System"
    DARTLING_BTM_5 = "Bloon Exclusion Zone"
    DARTLING_PARAGON = None

    BEAST_TOP_1 = "Piranha"
    BEAST_TOP_2 = "Barracuda"
    BEAST_TOP_3 = "Great White"
    BEAST_TOP_4 = "Orca"
    BEAST_TOP_5 = "Megalodon"
    BEAST_MID_1 = "Microraptor"
    BEAST_MID_2 = "Adasaurus"
    BEAST_MID_3 = "Velociraptor"
    BEAST_MID_4 = "Tyrannosaurus Rex"
    BEAST_MID_5 = "Giganotosaurus"
    BEAST_BTM_1 = "Gyrfalcon"
    BEAST_BTM_2 = "Horned Owl"
    BEAST_BTM_3 = "Golden Eagle"
    BEAST_BTM_4 = "Giant Condor"
    BEAST_BTM_5 = "Pouakai"
    BEAST_PARAGON = None

    SUPER_TOP_1 = "Laser Blasts"
    SUPER_TOP_2 = "Plasma Blasts"
    SUPER_TOP_3 = "Sun Avatar"
    SUPER_TOP_4 = "Sun Temple"
    SUPER_TOP_5 = "True Sun God"
    SUPER_MID_1 = "Super Range"
    SUPER_MID_2 = "Epic Range"
    SUPER_MID_3 = "Robo Monkey"
    SUPER_MID_4 = "Tech Terror"
    SUPER_MID_5 = "The Anti-Bloon"
    SUPER_BTM_1 = "Knockback"
    SUPER_BTM_2 = "Ultravision"
    SUPER_BTM_3 = "Dark Knight"
    SUPER_BTM_4 = "Dark Champion"
    SUPER_BTM_5 = "Legend of the Night"
    SUPER_PARAGON = None

    FARM_TOP_1 = "Increased Production"
    FARM_TOP_2 = "Greater Production"
    FARM_TOP_3 = "Banana Plantation"
    FARM_TOP_4 = "Banana Research Facility"
    FARM_TOP_5 = "Banana Central"
    FARM_MID_1 = "Long Life Bananas"
    FARM_MID_2 = "Valuable Bananas"
    FARM_MID_3 = "Monkey Bank"
    FARM_MID_4 = "IMF loan"
    FARM_MID_5 = "Monkey-Nomics"
    FARM_BTM_1 = "EZ Collect"
    FARM_BTM_2 = "Banana Salvage"
    FARM_BTM_3 = "Marketplace"
    FARM_BTM_4 = "Central Market"
    FARM_BTM_5 = "Monkey Wall Street"
    FARM_PARAGON = None

    DRUID_TOP_1 = "Hard Thorns"
    DRUID_TOP_2 = "Heart of Thunder"
    DRUID_TOP_3 = "Druid of the Storm"
    DRUID_TOP_4 = "Ball Lightning"
    DRUID_TOP_5 = "Superstorm"
    DRUID_MID_1 = "Thorn Swarm"
    DRUID_MID_2 = "Heart of Oak"
    DRUID_MID_3 = "Druid of the Jungle"
    DRUID_MID_4 = "Jungle's Bounty"
    DRUID_MID_5 = "Spirit of the Forest"
    DRIOD_BTM_1 = "Druidic Reach"
    DRUID_BTM_2 = "Heart of Vengeance"
    DRUID_BTM_3 = "Druid of Wrath"
    DRUID_BTM_4 = "Poplust"
    DRUID_BTM_5 = "Avatar of Wrath"
    DRUID_PARAGON = None

    ACE_TOP_1 = "Rapid Fire"
    ACE_TOP_2 = "Lots More Darts"
    ACE_TOP_3 = "Fighter Plane"
    ACE_TOP_4 = "Operation: Dart Storm"
    ACE_TOP_5 = "Sky Shredder"
    ACE_MID_1 = "Exploding Pineapple"
    ACE_MID_2 = "Spy Plane"
    ACE_MID_3 = "Bomber Ace"
    ACE_MID_4 = "Ground Zero"
    ACE_MID_5 = "Tsar Bomba"
    ACE_BTM_1 = "Sharper Darts"
    ACE_BTM_2 = "Centered Path"
    ACE_BTM_3 = "Neva-Miss Targeting"
    ACE_BTM_4 = "Spectre"
    ACE_BTM_5 = "Flying Fortress"
    ACE_PARAGON = "Goliath Doomship"

    HELI_TOP_1 = "Quad Darts"
    HELI_TOP_2 = "Pursuit"
    HELI_TOP_3 = "Razor Rotors"
    HELI_TOP_4 = "Apache Dartship"
    HELI_TOP_5 = "Apache Prime"
    HELI_MID_1 = "Bigger Jets"
    HELI_MID_2 = "IFR"
    HELI_MID_3 = "Downdraft"
    HELI_MID_4 = "Support Chinook"
    HELI_MID_5 = "Special Poperations"
    HELI_BTM_1 = "Faster Darts"
    HELI_BTM_2 = "Faster Firing"
    HELI_BTM_3 = "MOAB Shove"
    HELI_BTM_4 = "Comanche Defense"
    HELI_BTM_5 = "Comanche Commander"
    HELI_PARAGON = None

    BUCCANEER_TOP_1 = "Faster Shooting"
    BUCCANEER_TOP_2 = "Double Shot"
    BUCCANEER_TOP_3 = "Destroyer"
    BUCCANEER_TOP_4 = "Aircraft Carrier"
    BUCCANEER_TOP_5 = "Carrier Flagship"
    BUCCANEER_MID_1 = "Grape Shot"
    BUCCANEER_MID_2 = "Hot Shot"
    BUCCANEER_MID_3 = "Cannon Ship"
    BUCCANEER_MID_4 = "Monkey Pirates"
    BUCCANEER_MID_5 = "Pirate Lord"
    BUCCANEER_BTM_1 = "Long Range"
    BUCCANEER_BTM_2 = "Crow's Nest"
    BUCCANEER_BTM_3 = "Merchantman"
    BUCCANEER_BTM_4 = "Favored Trades"
    BUCCANEER_BTM_5 = "Trade Empire"
    BUCCANEER_PARAGON = "Navarch of the Seas"

    BOOMERANG_TOP_1 = "Improved Rangs"
    BOOMERANG_TOP_2 = "Glaives"
    BOOMERANG_TOP_3 = "Glaive Ricochet"
    BOOMERANG_TOP_4 = "M.O.A.R Glaives"
    BOOMERANG_TOP_5 = "Glaive Lord"
    BOOMERANG_MID_1 = "Faster Throwing"
    BOOMERANG_MID_2 = "Faster Rangs"
    BOOMERANG_MID_3 = "Bionic Boomerang"
    BOOMERANG_MID_4 = "Turbo Charge"
    BOOMERANG_MID_5 = "Perma Charge"
    BOOMERANG_BTM_1 = "Long Range Rangs"
    BOOMERANG_BTM_2 = "Red Hot Rangs"
    BOOMERANG_BTM_3 = "Kylie Boomerang"
    BOOMERANG_BTM_4 = "MOAB Press"
    BOOMERANG_BTM_5 = "MOAB Domination"
    BOOMERANG_PARAGON = "Glaive Dominus"

    WIZARD_TOP_1 = "Guided Magic"
    WIZARD_TOP_2 = "Arcane Blast"
    WIZARD_TOP_3 = "Arcane Mastery"
    WIZARD_TOP_4 = "Arcane Spike"
    WIZARD_TOP_5 = "Archmage"
    WIZARD_MID_1 = "Fireball"
    WIZARD_MID_2 = "Wall of Fire"
    WIZARD_MID_3 = "Dragon's Breath"
    WIZARD_MID_4 = "Summon Phoenix"
    WIZARD_MID_5 = "Wizard Lord Phoenix"
    WIZARD_BTM_1 = "Intense Magic"
    WIZARD_BTM_2 = "Monkey Sense"
    WIZARD_BTM_3 = "Shimmer"
    WIZARD_BTM_4 = "Necromancer: Unpopped Army"
    WIZARD_BTM_5 = "Prince of Darkness"
    WIZARD_PARAGON = "Magus Perfectus"

    NINJA_TOP_1 = "Ninja Discipline"
    NINJA_TOP_2 = "Sharp Shurikens"
    NINJA_TOP_3 = "Double Shot"
    NINJA_TOP_4 = "Bloonjitsu"
    NINJA_TOP_5 = "Grandmaster Ninja"
    NINJA_MID_1 = "Distraction"
    NINJA_MID_2 = "Counter-Espionage"
    NINJA_MID_3 = "Shinobi Tactics"
    NINJA_MID_4 = "Bloon Sabotage"
    NINJA_MID_5 = "Grand Saboteur"
    NINJA_BTM_1 = "Seeking Shuriken"
    NINJA_BTM_2 = "Caltrops"
    NINJA_BTM_3 = "Flash Bomb"
    NINJA_BTM_4 = "Sticky Bomb"
    NINJA_BTM_5 = "Master Bomber"
    NINJA_PARAGON = "Ascended Shadow"

    ICE_TOP_1 = "Permafrost"
    ICE_TOP_2 = "Cold Snap"
    ICE_TOP_3 = "Ice Shards"
    ICE_TOP_4 = "Embrittlement"
    ICE_TOP_5 = "Super Brittle"
    ICE_MID_1 = "Enhanced Freeze"
    ICE_MID_2 = "Deep Freeze"
    ICE_MID_3 = "Arctic Wind"
    ICE_MID_4 = "Snowstorm"
    ICE_MID_5 = "Absolute Zero"
    ICE_BTM_1 = "Larger Radius"
    ICE_BTM_2 = "Re-Freeze"
    ICE_BTM_3 = "Cryo Cannon"
    ICE_BTM_4 = "Icicles"
    ICE_BTM_5 = "Icicle Impale"
    ICE_PARAGON = None

    VILLAGE_TOP_1 = "Bigger Radius"
    VILLAGE_TOP_2 = "Jungle Drums"
    VILLAGE_TOP_3 = "Primary Training"
    VILLAGE_TOP_4 = "Primary Mentoring"
    VILLAGE_TOP_5 = "Primary Expertise"
    VILLAGE_MID_1 = "Grow Blocker"
    VILLAGE_MID_2 = "Radar Scanner"
    VILLAGE_MID_3 = "Monkey Intelligence Bureau"
    VILLAGE_MID_4 = "Call to Arms"
    VILLAGE_MID_5 = "Homeland Defense"
    VILLAGE_BTM_1 = "Monkey Business"
    VILLAGE_BTM_2 = "Monkey Commerce"
    VILLAGE_BTM_3 = "Monkey City"
    VILLAGE_BTM_4 = "Monkey Town"
    VILLAGE_BTM_5 = "Monkeyopolis"
    VILLAGE_PARAGON = None

    ALCHEMIST_TOP_1 = "Larger Potions"
    ALCHEMIST_TOP_2 = "Acidic Mixture Dip"
    ALCHEMIST_TOP_3 = "Berserker Brew"
    ALCHEMIST_TOP_4 = "Stronger Stimulant"
    ALCHEMIST_TOP_5 = "Permanent Brew"
    ALCHEMIST_MID_1 = "Stronger Acid"
    ALCHEMIST_MID_2 = "Perishing Potions"
    ALCHEMIST_MID_3 = "Unstable Concoction"
    ALCHEMIST_MID_4 = "Transforming Tonic"
    ALCHEMIST_MID_5 = "Total Transformation"
    ALCHEMIST_BTM_1 = "Faster Throwing"
    ALCHEMIST_BTM_2 = "Acid Pool"
    ALCHEMIST_BTM_3 = "Lead to Gold"
    ALCHEMIST_BTM_4 = "Rubber to Gold"
    ALCHEMIST_BTM_5 = "Bloon Master Alchemist"
    ALCHEMIST_PARAGON = None

    SUB_TOP_1 = "Longer Range"
    SUB_TOP_2 = "Advanced Intel"
    SUB_TOP_3 = "Submerge and Support"
    SUB_TOP_4 = "Bloontonium Reactor"
    SUB_TOP_5 = "Energizer"
    SUB_MID_1 = "Barbed Darts"
    SUB_MID_2 = "Heat-tipped Darts"
    SUB_MID_3 = "Ballistic Missile"
    SUB_MID_4 = "First Strike Capability"
    SUB_MID_5 = "Pre-emptive Strike"
    SUB_BTM_1 = "Twin Guns"
    SUB_BTM_2 = "Airburst Darts"
    SUB_BTM_3 = "Triple Guns"
    SUB_BTM_4 = "Armor Piercing Darts"
    SUB_BTM_5 = "Sub Commander"
    SUB_PARAGON = None

    MORTAR_TOP_1 = "Bigger Blast"
    MORTAR_TOP_2 = "Bloon Buster"
    MORTAR_TOP_3 = "Shockwave"
    MORTAR_TOP_4 = "The Big One"
    MORTAR_TOP_5 = "The Biggest One"
    MORTAR_MID_1 = "Faster Reload"
    MORTAR_MID_2 = "Rapid Reload"
    MORTAR_MID_3 = "Heavy Shells"
    MORTAR_MID_4 = "Artillery Battery"
    MORTAR_MID_5 = "Pop and Awe"
    MORTAR_BTM_1 = "Increased Accuracy"
    MORTAR_BTM_2 = "Burny Stuff"
    MORTAR_BTM_3 = "Signal Flare"
    MORTAR_BTM_4 = "Shattering Shells"
    MORTAR_BTM_5 = "Blooncineration"
    MORTAR_PARAGON = None

    SNIPER_TOP_1 = "Full Metal Jacket"
    SNIPER_TOP_2 = "Large Calibre"
    SNIPER_TOP_3 = "Deadly Precision"
    SNIPER_TOP_4 = "Maim MOAB"
    SNIPER_TOP_5 = "Cripple MOAB"
    SNIPER_MID_1 = "Night Vision Goggles"
    SNIPER_MID_2 = "Shrapnel Shot"
    SNIPER_MID_3 = "Bouncing Bullet"
    SNIPER_MID_4 = "Supply Drop"
    SNIPER_MID_5 = "Elite Sniper"
    SNIPER_BTM_1 = "Fast Firing"
    SNIPER_BTM_2 = "Even Faster Firing"
    SNIPER_BTM_3 = "Semi-Automatic"
    SNIPER_BTM_4 = "Full Auto Rifle"
    SNIPER_BTM_5 = "Elite Defender"
    SNIPER_PARAGON = None

    SPIKE_TOP_1 = "Bigger Stacks"
    SPIKE_TOP_2 = "White Hot Spikes"
    SPIKE_MID_1 = "Faster Production"
    SPIKE_MID_2 = "Even Faster Production"
    SPIKE_TOP_3 = "Spiked Balls"
    SPIKE_TOP_4 = "Spiked Mines"
    SPIKE_TOP_5 = "Super Mines"
    SPIKE_MID_3 = "MOAB SHREDR"
    SPIKE_MID_4 = "Spike Storm"
    SPIKE_MID_5 = "Carpet of Spikes"
    SPIKE_BTM_1 = "Long Reach"
    SPIKE_BTM_2 = "Smart Spikes"
    SPIKE_BTM_3 = "Long Life Spikes"
    SPIKE_BTM_4 = "Deadly Spikes"
    SPIKE_BTM_5 = "Perma-Spike"
    SPIKE_PARAGON = None

    @staticmethod
    def from_string(value: str) -> "Upgrade":
        quirky_names = {
            "Mortar Faster Reload": Upgrade.MORTAR_MID_1,
            "Bionc Boomerang": Upgrade.BOOMERANG_MID_3,  # Pro typo
            "Metal Freeze": Upgrade.ICE_TOP_2,
            "Mortar Rapid Reload": Upgrade.MORTAR_MID_2,
            "Alchemist Faster Throwing": Upgrade.ALCHEMIST_BTM_1,
            "Directed Spikes": Upgrade.SPIKE_BTM_2,
            "Soulbind": Upgrade.WIZARD_BTM_5,
            "Sentry Paragon": Upgrade.ENGINEER_TOP_5,
            # TODO theres a better way to do this dynamically
            "MonkeyBuccaneer Paragon": Upgrade.BUCCANEER_PARAGON,
            "DartMonkey Paragon": Upgrade.DART_PARAGON,
            "NinjaMonkey Paragon": Upgrade.NINJA_PARAGON,
            "BoomerangMonkey Paragon": Upgrade.BOOMERANG_PARAGON,
            "EngineerMonkey Paragon": Upgrade.ENGINEER_PARAGON,
            "MonkeyAce Paragon": Upgrade.ACE_PARAGON,
            "WizardMonkey Paragon": Upgrade.WIZARD_PARAGON,
        }
        if value in quirky_names.keys():
            return quirky_names[value]

        if value.startswith("Buccaneer-"):
            value = value[len("Buccaneer-"):]
        return upgrade_switch[value] if value in upgrade_switch else None


upgrade_switch = {}
for upgrade in Upgrade:
    upgrade_switch[upgrade.value] = upgrade


class Achievement(Enum):
    """
    *New in 0.5.0*

    Every achievement present in the game.
    """
    FIRST_WIN = "First Win"
    HERO_TIME = "Hero Time"
    HERO_POWERS_ACTIVATE = "Hero Powers Activate"
    BIGGER_BADDER = "Bigger, Badder"
    BIG_MONKEY = "Big Monkey"
    CHALLENGER = "Challenger"
    STUDENT = "Student"
    MEGA_MONKEY = "Mega Monkey"
    ROLE_REVERSER = "Role Reverser"
    MONKEY_AVENGER_LEAGUE = "Monkey Avenger League"
    SCHOLAR = "Scholar"
    NEXT_LEVEL = "Next Level"
    GRASSHOPPER = "Grasshopper"
    FIRST_MONKEYS_FIRST = "First Monkeys First"
    INFRARED = "Infrared"
    WAR_MONKEYS = "War Monkeys"
    YOUVE_GOT_THE_POWER = "You've Got the Power"
    CHALLENGE_APPRENTICE = "Challenge Apprentice"
    EPIC_HERO = "Epic Hero"
    SURVIVOR = "Survivor"
    ACOLYTE = "Acolyte"
    ABRACADABMONKEY = "Abracadabmonkey"
    MOAB_ASSASSIN = "MOAB Assassin"
    MEDAL_WINNER = "Medal Winner"
    OUR_POWERS_COMBINED = "Our Powers Combined"
    CLICKER = "Clicker"
    KNOWLEDGABLE_PRIMATE = "Knowledgable Primate"
    DECORATED_HERO = "Decorated Hero"
    BFB_BRAWLER = "BFB Brawler"
    ADVANCED_PLAYER = "Advanced Player"
    SUPERIOR_CLICKER = "Superior Clicker"
    POWER_USER = "Power User"
    PERFECT_WEEK = "Perfect Week"
    BIG_BLOONS = "Big Bloons"
    RED_AND_BLUE_MAKES = "Red and Blue Makes..."
    ROOKIE_OF_THE_YEAR = "Rookie of the year"
    THRIFTY = "Thrifty"
    COOPERATION = "Co-operation"
    TRIPLE_THREAT = "Triple Threat"
    KIND_BENEFACTOR = "Kind Benefactor"
    GENEROUS_BENEFACTOR = "Generous Benefactor"
    MONKEY_CONTRIBUTOR = "Monkey Contributor"
    FOUR_TIMES_THE_FUN = "Four times the fun"
    COLLABORATE = "Collaborate!"
    ME_DID_A_JOB_ON_DDT = "Me Did A Job on DDT"
    POWERSHARE = "Powershare"
    EMPOWERED = "Empowered"
    ALL_FOR_ONE_AND_ONE_FOR_ONE = "All for one and one for one"
    TETRIMINO = "Tetrimino"
    RAINBOW_IS_MAGIC = "Rainbow is Magic"
    RISING_STAR = "Rising star"
    ULTIMATE_CLICKER = "Ultimate Clicker"
    SMALL_BLOONS = "Small Bloons"
    ZOMGINATOR = "ZOMGinator"
    MASTER_OF_LIFE = "Master of Life"
    LOOKING_FAB = "Looking fab"
    WHEN_THE_GOING_GETS_TOUGH = "When the going gets tough..."
    TOWER_KEEPER = "Tower Keeper"
    DR_MONKEY = "Dr. Monkey"
    THERPOPYLAE = "Therpopylae"
    MONKEY_PHILANTHROPIST = "Monkey Philanthropist"
    I_SEE_YOU = "I see you"
    INDIE = "Indie"
    IMPOPPABLE = "Impoppable"
    POPPABLE = "Poppable"
    UNSUNG_MONKEYS = "Unsung Monkeys"
    A_CRATE_TIME = "A Crate Time"
    BLOONZILLA = "Bloonzilla!"
    GOLDEN_TICKET = "Golden Ticket"
    BILL_GREATES = "Bill Greates"
    CO_OP_POPPER = "Co-op Popper!"
    POWER_OVERWHELMING = "Power overwhelming!"
    STRANGELY_ADORABLE = "Strangely Adorable"
    ADVENTURER = "Adventurer"
    SEASONED_ADVENTURER = "Seasoned Adventurer"
    ACHIEVEMENT_OF_ACHIEVEMENTS = "Achievement Of Achievements"
    MONKEY_FAN_CLUB = "Monkey Fan Club"
    ALL_ABOUT_THAT_BLING = "All About That Bling"
    APOTHEOSIS = "Apotheosis"
    WHOS_THE_BOSS = "Who's the Boss"
    WHAT_IS_THIS_NEW_BLOONERY = "What is this new Bloonery"
    IM_THE_BOSS = "I'm the Boss"
    COUPON_CRAZY = "Coupon Crazy"
    MO_HEROES_MO_PROBLEMS = "Mo Heroes, Mo Problems"
    BIG_SPENDER = "Big Spender"
    ILL_BE_BACK = "I'll Be Back"
    TWO_TOWER_CHIMPS = "2TC"
    WHAT_DID_IT_COST = "What did it cost"
    REGIFTED = "Regifted"
    FULL_SPEED_AHEAD = "Full Speed Ahead!"
    NO_STONE_LEFT_UNTURNED = "No Stone Left Unturned"
    TOP_OF_YOUR_GAME = "Top of your game"
    SO_SPIIICEY_NINJA_KIWI = "So Spiiicey Ninj aKiwi"
    SNAP_OF_YOUR_FINGERS = "Snap of your fingers"
    SO_SHINY = "So Shiny"
    LIVING_ON_THE_EDGE = "Living on the Edge"
    MAGICAL_GOLD = "Magical Gold"
    HOOK_LINE_AND_SINKER = "Hook Line And Sinker"
    SUPER_BAD = "Super BAD"
    LIKE_A_BOSS = "Like a Boss"
    DAVIDS_VS_GOLIATH = "Davids Vs Goliath"
    TOOLS_TO_DARWIN = "Tools To Darwin"
    CHUNKY_MONKEYS = "Chunky Monkeys"
    NOT_LACKING_CRITICAL_INFORMATION = "Not Lacking Critical Information"
    SOCIAL_BUTTERFLY = "Social Butterfly"
    PERFECT_PARAGON = "Perfect Paragon"
    TERRITORY_SAMPLER = "Territory Sampler"
    CONQUESTED_TERRITORY = "Conquested Territory"
    INFLATED = "Inflated"
    OATHBREAKERS = "Oathbreakers"
    CHALLENGE_MASTER = "Challenge Master"
    NO_HARVEST = "No Harvest"
    STUBBORN_STRATEGY = "Stubborn Strategy"
    STAGE_OF_EMPIRES = "Stage of Empires"
    A_LA_CODE = "A La Code"
    AXIS_OF_HAVOK = "Axis of Havok"
    BLOON_MASTER_POPULOUS = "Bloon Master Populous"
    READY_PLAYER_ONE = "Ready Player One"
    THE_GREATEST_CHALLENGE = "The greatest challenge"
    LIMITE_DRUN = "Limited Run"
    TWELVE_TASKS_OF_MONKULES = "12 Tasks of Monk-ules"
    INVIGORATION = "Invigoration"
    STICKY_SITUATION = "Sticky Situation"
    BLOONTONA_500 = "Bloontona 500"
    SIDE_QUEST = "Side Quest"
    A_YEAR_IN_THE_MAKING = "A year in the making"

    @staticmethod
    def from_string(value: str) -> "Achievement":
        value = value.replace(" ", "")
        if value in achievement_switch:
            return achievement_switch[value]
        return None


achievement_switch = {}
for achievement in Achievement:
    achievement_switch[achievement.value.replace(" ", "")] = achievement
